/*
 * $Id: heap1.c,v 1.1 2005/03/02 21:00:52 raptor Exp $
 *
 * heap1.c - vulnerable program (Solaris/SPARC heap-based)
 * Copyright (c) 2005 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * Simple program vulnerable to an heap-based buffer overflow, specially
 * crafted for exploit research purposes in the Solaris/SPARC environment.
 *
 * See also The Shellcoder's Handbook (chapters 10 and 11) and the article 
 * "Once upon a free()..." (http://www.phrack.org/phrack/57/p57-0x09).
 */

int vuln(char *str)
{
	/* 
	 * the overflowed chunk must not be the last, the special bottom
	 * chunk: in that case it would not be merged with the fake chunk
	 * behind, because realfree would think it is the last chunk anyway
	 */
	char *buf = (char *)malloc(64);
	char *buf2 = (char *)malloc(64);

	strcpy(buf, str);

	/*
	 * we call free, but our chunk is just added to a "to-be-freed"
	 * list -- the real free process is done by the realfree function,
	 * which is called on two conditions:
	 * 1. a malloc() is called
	 * 2. more than FREESIZE free() calls (the list would overflow)
	 */
	free(buf);
	buf = (char *)malloc(256);

	return(0);
}

int main(int argc, char **argv)
{
	vuln(argv[1]);

	return(0);
}
